include masm32rt.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm

WndProc proto :DWORD,:DWORD,:DWORD,:DWORD

WND_DATA struct
	hdc			HDC 	?
	bDrag		DWORD	?
	pos			DWORD	?
WND_DATA ends

DWM_BLURBEHIND struct
	dwFlags					DWORD	?
	fEnable					BOOL	?
	hRgnBlur				HRGN	?
	fTransitionOnMaximized	BOOL 	?
DWM_BLURBEHIND ends

DWMENABLEBLURBEHINDWINDOW typedef proto hWnd:HWND,pBlurBehind:ptr DWM_BLURBEHIND
PDWMENABLEBLURBEHINDWINDOW typedef ptr DWMENABLEBLURBEHINDWINDOW

.data
	ClassName		db "MainClass32",0
	AppName			db "Main Window",0
.data?
	hInstance					HINSTANCE	?
	DwmEnableBlurBehindWindow	PDWMENABLEBLURBEHINDWINDOW	?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG

	mov esi,rv(LoadLibrary,"Dwmapi.dll")
	.if !esi
		fn MessageBox,0,"DWM not available","error",0
		invoke ExitProcess,0
	.endif
	mov DwmEnableBlurBehindWindow,rv(GetProcAddress,esi,"DwmEnableBlurBehindWindow")

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(CreateSolidBrush,0)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,OFFSET ClassName
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,OFFSET ClassName,OFFSET AppName,WS_VISIBLE or WS_POPUP,1,1,1,1,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID
LOCAL bitmap:PVOID
LOCAL bmpData:BitmapData
LOCAL rectf:RectF
LOCAL rect[2]:RECT
LOCAL region:PVOID
LOCAL path:PVOID
LOCAL hRgn:HRGN
LOCAL pen:PVOID
LOCAL pt:POINT
LOCAL dbh:DWM_BLURBEHIND

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_CREATE
		
		;/* create region that lies outside the client area */
		invoke CreateRectRgn,-10,-10,-9,-9
	
		;/* this makes the client area transparent - black (0xff000000) also becomes transparent! */
		;/* The blure effect will be applied to the region, which is not visible.                 */
		;/* It is recommended to use GDI+ for further drawing.                                    */
		mov dbh.dwFlags,1 or 2;DWM_BB_ENABLE
		mov dbh.fEnable,TRUE
		mov dbh.hRgnBlur,eax
		mov dbh.fTransitionOnMaximized,0
		invoke DwmEnableBlurBehindWindow,hWnd,ADDR dbh

		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		invoke GdipGraphicsClear,graphics,0ff000000h
		
		;/* load bitmap data */
		invoke GdipCreateBitmapFromFile,uni$("windows.png"),ADDR bitmap
		.if eax != GpStatusOk
			invoke MessageBox,0,0,0,0
		.endif
				
		invoke GetClientRect,hWnd,ADDR rect
		invoke ClientToScreen,hWnd,ADDR rect
		invoke GdipGetImageWidth,bitmap,ADDR rect.right
		invoke GdipGetImageHeight,bitmap,ADDR rect.bottom
		mov eax,rect.right
		add rect.left,eax
		mov eax,rect.bottom
		add rect.top,eax
		
		;/* center window */
		mov esi,rv(GetSystemMetrics,SM_CXSCREEN)
		mov edi,rv(GetSystemMetrics,SM_CYSCREEN)
		shr esi,1
		shr edi,1
		mov eax,rect.right
		mov edx,rect.bottom
		shr eax,1
		shr edx,1
		sub esi,eax
		sub edi,edx
		invoke SetWindowPos,hWnd,0,esi,edi,rect.right,rect.bottom,SWP_NOZORDER
		
		invoke CreateRectRgn,0,0,rect.right,rect.bottom
		invoke SetWindowRgn,hWnd,eax,1
		
		invoke GdipDrawImageI,graphics,bitmap,0,0
		
		invoke GdipDisposeImage,bitmap
		invoke GdipDeletePath,path
		invoke GdipDeleteRegion,region
		invoke GdipDeleteGraphics,graphics


	.elseif uMsg == WM_LBUTTONDOWN
		invoke GetCursorPos,ADDR pt
		mov edx,pt.y
		shl edx,16
		or edx,pt.x
		invoke SetWindowLong,hWnd,WND_DATA.pos,edx
		invoke SetWindowLong,hWnd,WND_DATA.bDrag,1
		invoke SetCapture,hWnd
	.elseif uMsg == WM_LBUTTONUP
		invoke SetWindowLong,hWnd,WND_DATA.bDrag,0
		invoke ReleaseCapture
	.elseif uMsg == WM_MOUSEMOVE
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.bDrag)
		.if ebx
			mov ebx,rv(GetWindowLong,hWnd,WND_DATA.pos)
			invoke GetWindowRect,hWnd,ADDR rect
			invoke GetCursorPos,ADDR pt
			movzx ecx,bx
			mov edx,ebx
			shr edx,16
			mov eax,ecx
			mov ecx,pt.x
			sub ecx,eax
			mov eax,edx
			mov edx,pt.y
			sub edx,eax
			add rect.left,ecx
			add rect.top,edx
			invoke SetWindowPos,hWnd,0,rect.left,rect.top,0,0,SWP_NOSIZE or SWP_NOZORDER
			mov edx,pt.y
			shl edx,16
			or edx,pt.x
			invoke SetWindowLong,hWnd,WND_DATA.pos,edx
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

end main
